unit uListadoProblemasODDFACE;

{$mode delphi}

interface

uses
  SysUtils, Classes, Controls,
  Forms,
  Graphics,
  urosx, uDataSetGenerico,
  StdCtrls, uvisordetabla,
  uempaquetar,
  uconstantesSimSEE, unotificar, u_editorproblema,
  uoddface_consultar,
  u_updownload, uListadoProblemas;

type
  TListadoProblemasODDFACE = class(TListadoProblemas)
  public
    procedure Editar_onClick(nidRec: string; kFila: integer); override;
    procedure SemaforoRojo_OnClick(nidRec: string; kFila: integer); override;
    procedure SemaforoVerde_OnClick(nidRec: string; kFila: integer); override;
    procedure Lupa_OnClick(nidRec: string; kFila: integer); override;
    procedure clonar_OnClick(nidRec: string; kFila: integer); override;
    procedure Populate; override;
    class function CrearNuevoProblema: integer;
  end;




implementation

uses
  uoddface_prepare;

procedure CrearTabla_Inidviduos(nid_Problema: integer);
var
  sql: string;

begin
  sql := 'CREATE TABLE `ofe_individuos_' + IntToStr(
    nid_problema) + '` (' + '  `nid` int(11) NOT NULL,' + '  `adn` varbinary( 800 ) NOT NULL,' +
    '  `dtc` datetime NOT NULL,' + '  `dtu` datetime NOT NULL,' +
    '  `f_VE` double NOT NULL,' + '  `f_CVaR` double NOT NULL,' +
    '  `f_VaR` double NOT NULL,' + '  `f_Objetivo` double NOT NULL,' +
    '  `f_MIN` double NOT NULL,' + '  `f_MAX` double NOT NULL,' +
    '  `cnt_evaluaciones` int(11) NOT NULL,' + '  `detalle` blob NOT NULL,' +
    '  PRIMARY KEY  (`nid`),' + '  UNIQUE KEY `iadn` (`adn`),' +
    '  KEY `ifo` (`f_objetivo`)' + ') ENGINE=MyISAM DEFAULT CHARSET=latin1;';
  urosx.sql_exec(sql);

end;



class function TListadoProblemasODDFACE.CrearNuevoProblema: integer;
var

  nid_problema: integer;
  sql: string;
  str_nombres, str_valores: string;
begin

  nid_problema := sql_nextnid('ofe_problemas');

  AppendToInsertStr(str_nombres, str_valores, 'nid', IntToStr(nid_problema));

  AppendToInsertStr(str_nombres, str_valores, 'usuario', '0');
  AppendToInsertStr(str_nombres, str_valores, 'llave', '0');
  AppendToInsertStr(str_nombres, str_valores, 'dt_creacion', 'now()', False);
  AppendToInsertStr(str_nombres, str_valores, 'tipo', '0');

  AppendToInsertStr(str_nombres, str_valores, 'ro_VE', '1.0');
  AppendToInsertStr(str_nombres, str_valores, 'ro_VaR', '0.0');
  AppendToInsertStr(str_nombres, str_valores, 'ro_CVaR', '0.0');

  AppendToInsertStr(str_nombres, str_valores, 'N_CronicasPorVez', '100');
  AppendToInsertStr(str_nombres, str_valores, 'N_DiscretizacionesHistograma', '100');
  AppendToInsertStr(str_nombres, str_valores, 'semilla_madre', '31');

  AppendToInsertStr(str_nombres, str_valores, 'ro_GA', '0.95');
  AppendToInsertStr(str_nombres, str_valores, 'ro_EG', '0.00');
  AppendToInsertStr(str_nombres, str_valores, 'ro_MJ', '0.05');

  AppendToInsertStr(str_nombres, str_valores, 'GA_prob_premio_exito', '0.05');
  AppendToInsertStr(str_nombres, str_valores, 'GA_prob_mutacion', '0.01');
  AppendToInsertStr(str_nombres, str_valores, 'descripcion', '');




  sql := 'INSERT INTO ofe_problemas ( ' + str_nombres + ' ) VALUES ( ' + str_valores + ' ) ';

  writeln(sql);
  urosx.sql_exec(sql);

  CrearTabla_Inidviduos(nid_Problema);

  Result := nid_problema;
end;




function eliminarProblema(nidCarpeta: string): boolean;
var
  pathCarpeta: string;
  texto: string;
  sql: string;
begin
  Result := False;
  pathCarpeta := sql_func('SELECT path FROM ofe_carpetas WHERE nid = ' +
    nidCarpeta + ' LIMIT 1');

  texto := '¿Confirma que desea eliminar el Problema: ' + nidCarpeta +
    ' con todos sus archivos?';

  if confirmar(texto, ['Si', 'No']) = 'Si' then
  begin
    sql := 'DELETE FROM ofe_archivos WHERE nid_carpeta = ' + nidCarpeta;
    if not sql_exec(sql) then
      raise Exception.Create(urosx.UltimoError);

    sql := 'DELETE FROM ofe_carpetas WHERE nid = ' + nidCarpeta;
    if not sql_exec(sql) then
      raise Exception.Create(urosx.UltimoError);

    sql := 'DROP TABLE ofe_individuos_' + nidCarpeta;
    sql_exec(sql);
    //      raise Exception.Create( urosx.UltimoError );



    sql := 'DELETE FROM ofe_PIG_tecnologias WHERE nid_problema = ' + nidCarpeta;
    if not sql_exec(sql) then
      raise Exception.Create(urosx.UltimoError);


    sql := 'DELETE FROM ofe_PAM_ordenes WHERE nid_problema = ' + nidCarpeta;
    if not sql_exec(sql) then
      raise Exception.Create(urosx.UltimoError);


    sql := 'DELETE FROM ofe_problemas WHERE nid = ' + nidCarpeta;
    if not sql_exec(sql) then
      raise Exception.Create(urosx.UltimoError);

    Result := True;
  end;
end;

procedure TListadoProblemasODDFACE.Populate;
var
  k: integer;
  snid: string;
  ds: TResultadoQuery;
  r: TDataRecord;
  estado: integer;

begin
  flg_populate := False;
  ds := TResultadoQuery.CreateQuery(
    'SELECT nid, dt_creacion, tipo, descripcion,  estado FROM ofe_problemas ORDER BY nid DESC');
  if ds = nil then
    raise Exception.Create(urosx.ultimoError);

  ClearRedim(ds.nrows + 1, 7);
  // fila encabezado
  wrTexto('', 0, 0, 'NID');
  wrTexto('', 0, 1, 'dt_creacion');
  wrTexto('', 0, 2, 'tipo');
  wrTexto('', 0, 3, 'Descripcion');

  AlinearCelda(0, 0, CAH_Izquierda, CAV_Centro);
  AlinearCelda(0, 1, CAH_Izquierda, CAV_Centro);
  AlinearCelda(0, 2, CAH_Izquierda, CAV_Centro);
  AlinearCelda(0, 3, CAH_Izquierda, CAV_Centro);


  Self.SetBgColorFila(0, clNavy);
  Self.SetFontColorFila(0, clYellow);

  Self.SetBgColorCelda(0, 0, clNavy);
  Self.SetBgColorCelda(0, 1, clNavy);

  k := 1;
  r := ds.First;
  while not ds.EOF do
  begin
    snid := r.GetByIdAsString(0);
    estado := r.GetByNameAsInt('estado');
    wrTexto('', k, 0, r.GetByNameAsString('nid'));
    wrTexto('', k, 1, r.GetByNameAsString('dt_creacion'));
    wrTexto('', k, 2, r.GetByNameAsString('tipo'));
    wrTexto('', k, 3, r.GetByNameAsString('descripcion'));
    AlinearCelda(k, 0, CAH_Izquierda, CAV_Centro);
    AlinearCelda(k, 1, CAH_Izquierda, CAV_Centro);
    AlinearCelda(k, 2, CAH_Izquierda, CAV_Centro);
    AlinearCelda(k, 3, CAH_Izquierda, CAV_Centro);

    // ahora la botonera en la última columna

    wrBotonera(snid, k, 4,
      [iid_fdownload, iid_Editar, iid_borrar, iid_clonar],
      [hintPorDefecto(iid_fdownload),
      hintPorDefecto(iid_Editar),
      hintPorDefecto(iid_Borrar),
      hintPorDefecto(iid_clonar)]);


    if (estado <= 0) then
      wrBotonera(snid, k, 5, [iid_SemaforoRojo, iid_Lupa], ['Activar', 'Consultar'])
    else
      wrBotonera(snid, k, 5, [iid_SemaforoVerde, iid_Lupa], ['Desactivar',
        'Consultar']);


    if (k mod 2) = 0 then
      if estado <= 0 then
        SetBgColorFila(k, clFondoFilaPar_Inactiva)
      else
        SetBgColorFila(k, clFondoFilaPar_Activa)
    else
    if estado <= 0 then
      SetBgColorFila(k, clFondoFilaImpar_Inactiva)
    else
      SetBgColorFila(k, clFondoFilaImpar_Activa);

    Inc(k);
    r := ds.Next;
  end;
  reposicionar;
end;

procedure TListadoProblemasODDFACE.Editar_onClick(nidRec: string; kFila: integer);
var
  ufp: TForm_EditorProblema;
  res: integer;

begin

  ufp := TForm_EditorProblema.Create(self);

  ufp.LoadRec(StrToInt(nidRec));
  res := ufp.ShowModal;
  if res > 0 then
  begin
    flg_populate := True;
    invalidate;
  end;
  ufp.Free;

end;


procedure TListadoProblemasODDFACE.SemaforoRojo_OnClick(nidRec: string; kFila: integer);
var
  sql: string;
begin
  sql := 'UPDATE ofe_problemas SET estado = 1 - estado  WHERE nid = ' + nidRec + ' LIMIT 1 ';
  urosx.sql_exec(sql);
  flg_populate := True;
  invalidate;
end;

procedure TListadoProblemasODDFACE.SemaforoVerde_OnClick(nidRec: string; kFila: integer);
var
  sql: string;
begin
  sql := 'UPDATE ofe_problemas SET estado = - estado WHERE nid = ' + nidRec + ' LIMIT 1 ';
  urosx.sql_exec(sql);
  flg_populate := True;
  invalidate;
end;

procedure TListadoProblemasODDFACE.Lupa_OnClick(nidRec: string; kFila: integer);
var
  fc: TConsultar;
begin
  fc := TConsultar.Create(self);
  fc.eFrom.Text := 'ofe_individuos_' + nidRec;
  fc.nidProblema := StrToInt(nidRec);
  fc.ShowModal;
  fc.Free;
end;


procedure TListadoProblemasODDFACE.clonar_OnClick(nidRec: string; kFila: integer);
var
  nid_problema_destino, nid_problema_origen: integer;
begin
  nid_problema_origen := StrToInt(nidRec);
  nid_problema_destino := clonar_rec('ofe_problemas', nid_problema_origen,
    -1, 'estado=0, dt_creacion=now()');

  // cada problema tiene una carpeta con el mismo nid del problema.
  clonar_rec('ofe_carpetas', nid_problema_origen, nid_problema_destino, '');

  // Clonamos los archivos que pudiera tener la carpeta
  clonar_hijas('ofe_carpetas', 'ofe_archivos', 'nid_carpeta',
    nid_problema_origen, nid_problema_destino);

  // Clonamos los PIGs
  clonar_hijas('ofe_problemas', 'ofe_PIG_tecnologias', 'nid_problema',
    nid_problema_origen, nid_problema_destino);

  // Clonamos los PAMs
  clonar_hijas('ofe_problemas', 'ofe_PAM_ordenes', 'nid_problema',
    nid_problema_origen, nid_problema_destino);

  // creamos la tabla par el historial de evaluaciones
  CrearTabla_Inidviduos(nid_Problema_destino);

  Editar_onClick(IntToStr(nid_problema_destino), 0);
end;

end.


