unit uexploradorCF;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  Math, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  xmatdefs, uEstados, ufechas, AlgebraC, MatCPX, IntPoint;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1:     TButton;
    Button4: TButton;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    Button2:     TButton;
    Button3:     TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    CF: TAdminEstados;


  end;

var
  Form1: TForm1;

implementation

{$IFNDEF FPC}
  {$R *.dfm}

{$ELSE}
  {$R *.lfm}
{$ENDIF}


procedure TForm1.Button1Click(Sender: TObject);
var
  archi:     string;
  fCosto:    TMatOfNReal;
  nPasos, nEstrellas: integer;
  kPasoT:    integer;
  anio, semana, H, Stock: integer;
  dCFdX_Inc, dCFdX_Dec: NReal;
  fecha:     TFecha;
  semana_:   integer;
  fsal_bellman: textfile;
  error_str: string;
  CF1, CF2:  NReal;

begin

  if OpenDialog1.Execute then
  begin
    if CF <> nil then
      CF.Free;
    archi := OpenDialog1.FileName;
    CF    := TAdminEstados.CreateLoadFromArchi(archi);

    // antes de seguir chequeamos que se trate de una CF
    // con solo dos variables de estado y que sean Bonete y H en ese orden.
    error_str := '';
    if CF.nVarsContinuas <> 2 then
      error_str := error_str + '; CF.nVarsContinuas <> 2';
    if CF.nVarsDiscretas <> 0 then
      error_str := error_str + '; CF.nVarsDiscretas <> 2';
    if CF.xr_def[0].NPuntos <= 1 then
      error_str := error_str + '; CF.xr_def[0].NPuntos <= 1';
    if CF.xr_def[0].nombre <> 'Bonete_Vol' then
      error_str := error_str + '; CF.xr_def[0].nombre <> ''Bonete_Vol''';
    if CF.xr_def[1].nombre <> 'Estado_H' then
      error_str := error_str + '; CF.xr_def[1].nombre <> ''Estado_H''';
    if error_str <> '' then
    begin
      CF.Free;
      CF := nil;
      raise Exception.Create('El archivo CF.bin no tiene las definiciones esperadas.' +
        error_str);
    end;

    fecha      := TFecha.Create_Clone(CF.fechaIni);
    fCosto     := CF.constelacion.fCosto;
    nPasos     := length(fCosto);
    nEstrellas := length(fCosto[0]);


    assignfile(fsal_bellman, 'bellman_paraOperGen.txt');
    rewrite(fsal_bellman);

    semana_ := 0;
    for kPasoT := 1 to nPasos - 1 do
    begin
      anio   := fecha.anio;
      semana := fecha.semana52;
      if semana_ <> semana then
      begin
        semana_ := semana;
        for H := 1 to CF.xr_def[1].NPuntos do
          for Stock := 0 to CF.xr_def[0].NPuntos - 1 do
          begin
(*
            // Posicionamos el estado Borde inferior del stock
            CF.xr[0] := CF.xr_def[0].x[stock - 1];
            CF.xr[1] := CF.xr_def[1].x[H - 1];
            // Guardamos el valor de Bellman en el extremo inferior
            CF1      := CF.costoContinuo(kPasoT);
*)
            // Posicionamos el estado Borde superior del stock
            CF.xr[0] := CF.xr_def[0].x[stock];
            CF.xr[1] := CF.xr_def[1].x[H - 1];
            // Guardamos el valor de Bellman en el extremo inferior
            CF2      := CF.costoContinuo(kPasoT);


          (*  imprimimos segn formato enviado por Milton
          AO      NUMBER(4)
          SEMANA   NUMBER(2)
          CLASE    NUMBER(2)
          PASO     NUMBER(2)
          BELLMAN  NUMBER(15,3)
           *)
           (*
            writeln(fsal_bellman, anio: 4, ' ', semana: 2, ' ', H: 2, ' ',
              Stock: 2, (CF1 + CF2) / 2.0: 15: 3);
*)
            writeln(fsal_bellman, anio: 4, ' ', semana: 2, ' ', H: 2, ' ',
              Stock: 2, CF2: 15: 3);

          end;
      end;
      fecha.dt := fecha.dt + CF.horasDelPaso / 24.0;
    end;
    closefile(fsal_bellman);
  end;
end;


function nextpal(var s: string): string;
var
  i:   integer;
  res: string;
begin
  i := pos(#9, s);
  if i > 0 then
  begin
    res := copy(s, 1, i - 1);
    Delete(s, 1, i);
  end
  else
  begin
    res := s;
    s   := '';
  end;
  Result := s;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  archi: string;
  buff: array[1..10] of TDAOfNReal;
  //array [1..10*5*5*5] of NReal;
  ent, sal: textfile;
  i:    integer;
  r:    string;
  pal:  string;
  N:    integer;
  paux: TDAOfNreal;
begin
  N := 10 * 5 * 5 * 5;

  if OpenDialog1.Execute then
  begin
    archi := OpenDialog1.FileName;
    assignfile(ent, archi);
    reset(ent);

    for i := 1 to 10 do
      setlength(buff[i], N);

    while not EOF(ent) do
    begin
      readln(ent, r);

      paux := buff[1];
      for i := 1 to 9 do
        buff[i] := buff[i + 1];
      buff[10]  := paux;

      for i := 0 to N - 1 do
      begin
        pal     := nextpal(r);
        paux[i] := StrToFloat(pal);
      end;

    end;
    closefile(ent);

  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  archi:  string;
  fCosto: TMatOfNReal;
  nPasos, nEstrellas: integer;
  k, j:   integer;
begin
  if OpenDialog1.Execute then
  begin
    if CF <> nil then
      CF.Free;
    archi  := OpenDialog1.FileName;
    CF     := TAdminEstados.CreateLoadFromArchi(archi);
    fCosto := CF.constelacion.fCosto;
    nPasos := length(fCosto);
    nEstrellas := length(fCosto[0]);
    for k := 0 to nPasos - 1 do
      for j := 0 to nEstrellas - 1 do
        fCosto[k][j] := fCosto[k][j] / 10;
    CF.storeInArchi(archi);
  end;
end;




procedure TForm1.Button4Click(Sender: TObject);
var
  archi:  string;
  fCosto: TMatOfNReal;
  nPasos, nEstrellas: integer;
  k, j:   integer;

  xr: TDAOfNReal;
  xd: TDAOfNInt;

  NVertices: Integer;
  vertices: TDAOfNComplex;

begin
  if OpenDialog1.Execute then
  begin
    if CF <> nil then
      CF.Free;
    archi  := OpenDialog1.FileName;
    CF     := TAdminEstados.CreateLoadFromArchi(archi);
    CF.constelacion.PrintDefsToText( output, false );


    fCosto := CF.constelacion.fCosto;
    nPasos := length(fCosto);
    nEstrellas := length(fCosto[0]);

    NVertices:= 1 SHL (CF.constelacion.nContinuas + CF.constelacion.nDiscretas );

    setlength( xr, CF.constelacion.nContinuas );
    setlength( xd, CF.constelacion.nDiscretas );


    for k:= 0 to CF.constelacion.nContinuas-1 do
    begin
    end;


    setlength( vertices, NVertices );

    for k := 0 to nPasos - 1 do
      for j := 0 to nEstrellas - 1 do
        fCosto[k][j] := fCosto[k][j] / 10;
    CF.storeInArchi(archi);
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  fCosto: TMatOfNReal;
  nPasos, nEstrellas: integer;
  k, j:   integer;
  archi2: String;
  archi1: String;

  CF1, CF2: TAdminEstados;
  fCosto1: TMatOfNReal;
  nPasos1: Integer;
  nEstrellas1: Integer;
  fCosto2: TMatOfNReal;
  nPasos2: Integer;
  nEstrellas2: Integer;

  iguales:Boolean;
  dist: NReal;
  dist_: Extended;
begin
  iguales := True;
  if OpenDialog1.Execute then
   begin
    archi1  := OpenDialog1.FileName;
    if OpenDialog1.Execute then
     begin
      archi2  := OpenDialog1.FileName;
      CF1:= TAdminEstados.CreateLoadFromArchi(archi1);
      CF2:= TAdminEstados.CreateLoadFromArchi(archi2);

      fCosto1 := CF1.constelacion.fCosto;
      nPasos1 := length(fCosto1);
      nEstrellas1 := length(fCosto1[0]);
      fCosto2 := CF2.constelacion.fCosto;
      nPasos2 := length(fCosto2);
      nEstrellas2 := length(fCosto2[0]);

      dist:=0;
      if ((nPasos1 <> nPasos2) and (nEstrellas1<>nEstrellas2)) then
       iguales:=False
      else
       begin
         for k := nPasos1 - 1 downto 0  do
         begin
           //readln;
           for j := 0 to nEstrellas1 - 1 do
             begin
               if fCosto1[k][j] <> 0 then
               begin
                dist_ := (abs(fCosto1[k][j]-fCosto2[k][j]))*100/fCosto1[k][j];
                if dist_> dist then
                   dist:=dist_;
                //  abs(fCosto1[k][j]-fCosto2[k][j]);
                 iguales:=false;
                 //Break;
               end;

             end;

         end;
       end;
       writeln(iguales,' ',k,' ',j,' ',dist);
     end;
  end;
end;



end.

